Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.App/Runner.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.App/Runner.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.App/Runner.cs	(revision 17519)
@@ -16,19 +16,23 @@
   internal static class Runner {
     internal static void Run(string template, string config, string outputFile) {
-      InstantiatorResult instantiatorResult = JsonTemplateInstantiator.Instantiate(template, config);
-      IOptimizer optimizer = instantiatorResult.Optimizer;
-      IEnumerable<IResultJsonItem> configuredResultItem = instantiatorResult.ConfiguredResultItems;
+      try {
+        InstantiatorResult instantiatorResult = JsonTemplateInstantiator.Instantiate(template, config);
+        IOptimizer optimizer = instantiatorResult.Optimizer;
+        IEnumerable<IResultJsonItem> configuredResultItem = instantiatorResult.ConfiguredResultItems;
 
-      optimizer.Runs.Clear();
-      if(optimizer is EngineAlgorithm e)
-        e.Engine = new ParallelEngine.ParallelEngine();
-      
-      Task task = optimizer.StartAsync();
-      while(!task.IsCompleted) {
+        optimizer.Runs.Clear();
+        if (optimizer is EngineAlgorithm e)
+          e.Engine = new ParallelEngine.ParallelEngine();
+
+        Task task = optimizer.StartAsync();
+        while (!task.IsCompleted) {
+          WriteResultsToFile(outputFile, optimizer, configuredResultItem);
+          Thread.Sleep(100);
+        }
+
         WriteResultsToFile(outputFile, optimizer, configuredResultItem);
-        Thread.Sleep(100);
+      } catch (Exception e) {
+        File.WriteAllText(outputFile, e.Message + "\n\n\n\n" + e.StackTrace);
       }
-     
-      WriteResultsToFile(outputFile, optimizer, configuredResultItem);
     }
 
@@ -47,4 +51,8 @@
           if (configuredResults.Contains(res.Key)) {
             if (res.Value is ISymbolicRegressionSolution solution) {
+              /* TEST */
+              var csFormatter = new CSharpSymbolicExpressionTreeStringFormatter();
+              File.WriteAllText(@"C:\Workspace\output\csFormatted.cs", csFormatter.Format(solution.Model.SymbolicExpressionTree));
+              /* END TEST */
               var formatter = new SymbolicDataAnalysisExpressionMATLABFormatter();
               var x = formatter.Format(solution.Model.SymbolicExpressionTree);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 17519)
@@ -108,4 +108,6 @@
     </Compile>
     <Compile Include="ViewModels\ArrayValueVM.cs" />
+    <Compile Include="ViewModels\DoubleVMs.cs" />
+    <Compile Include="ViewModels\IntVMs.cs" />
     <Compile Include="ViewModels\JsonItemVMBase.cs" />
     <Compile Include="ViewModels\LookupJsonItemVM.cs" />
@@ -117,4 +119,10 @@
     <Compile Include="ViewModels\StringValueVM.cs" />
     <Compile Include="ViewModels\ValueLookupJsonItemVM.cs" />
+    <Compile Include="Shared\ConcreteItemsRestrictor.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Shared\ConcreteItemsRestrictor.Designer.cs">
+      <DependentUpon>ConcreteItemsRestrictor.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\ExportJsonDialog.cs">
       <SubType>Form</SubType>
@@ -124,4 +132,10 @@
     </Compile>
     <Compile Include="FileManager.cs" />
+    <Compile Include="Views\JsonItemConcreteItemArrayControl.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\JsonItemConcreteItemArrayControl.Designer.cs">
+      <DependentUpon>JsonItemConcreteItemArrayControl.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\JsonItemMultiValueControl.cs">
       <SubType>UserControl</SubType>
@@ -224,6 +238,12 @@
       <DependentUpon>NumericRangeControl.cs</DependentUpon>
     </EmbeddedResource>
+    <EmbeddedResource Include="Shared\ConcreteItemsRestrictor.resx">
+      <DependentUpon>ConcreteItemsRestrictor.cs</DependentUpon>
+    </EmbeddedResource>
     <EmbeddedResource Include="Views\ExportJsonDialog.resx">
       <DependentUpon>ExportJsonDialog.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Views\JsonItemConcreteItemArrayControl.resx">
+      <DependentUpon>JsonItemConcreteItemArrayControl.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="Views\JsonItemMultiValueControl.resx">
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.Designer.cs	(revision 17519)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.Designer.cs	(revision 17519)
@@ -0,0 +1,61 @@
+﻿namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  partial class ConcreteItemsRestrictor {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tableOptions = new System.Windows.Forms.TableLayoutPanel();
+      this.SuspendLayout();
+      // 
+      // tableOptions
+      // 
+      this.tableOptions.AutoScroll = true;
+      this.tableOptions.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.tableOptions.ColumnCount = 2;
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
+      this.tableOptions.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableOptions.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableOptions.Location = new System.Drawing.Point(0, 0);
+      this.tableOptions.Name = "tableOptions";
+      this.tableOptions.RowCount = 1;
+      this.tableOptions.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.tableOptions.Size = new System.Drawing.Size(500, 200);
+      this.tableOptions.TabIndex = 13;
+      // 
+      // ConcreteItemsRestrictor
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tableOptions);
+      this.Margin = new System.Windows.Forms.Padding(0);
+      this.Name = "ConcreteItemsRestrictor";
+      this.Size = new System.Drawing.Size(500, 200);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TableLayoutPanel tableOptions;
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.cs	(revision 17519)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Shared/ConcreteItemsRestrictor.cs	(revision 17519)
@@ -0,0 +1,59 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public partial class ConcreteItemsRestrictor : UserControl {
+
+    public event Action<object> OnChecked;
+    public event Action<object> OnUnchecked;
+
+    public ConcreteItemsRestrictor() {
+      InitializeComponent();
+    }
+
+    public void Init<T>(IEnumerable<T> objs) {
+      if(objs != null) {
+        foreach(var obj in objs) {
+          SetupOption(obj);
+        }
+      }
+    }
+
+    private void SetupOption(object opt) {
+      AddComboOption(opt);
+      TextBox tb = new TextBox();
+      tb.Text = opt.ToString();
+      tb.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
+      tb.ReadOnly = true;
+
+      CheckBox checkBox = new CheckBox();
+      checkBox.Checked = true;
+
+      checkBox.CheckStateChanged += (o, args) => {
+        if (checkBox.Checked)
+          AddComboOption(opt);
+        else
+          RemoveComboOption(opt);
+      };
+      tableOptions.Controls.Add(checkBox);
+      tableOptions.Controls.Add(tb);
+    }
+
+    private void AddComboOption(object obj) {
+      OnChecked?.Invoke(obj);
+      tableOptions.Refresh();
+    }
+
+    private void RemoveComboOption(object obj) {
+      OnUnchecked?.Invoke(obj);
+      tableOptions.Refresh();
+    }
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/ArrayValueVM.cs	(revision 17519)
@@ -9,25 +9,11 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
 
-  public class DoubleArrayValueVM : ArrayValueVM<double, DoubleArrayJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleArrayJsonItem);
+  
 
-    protected override double MinTypeValue => double.MinValue;
 
-    protected override double MaxTypeValue => double.MaxValue;
 
-    public override UserControl Control =>
-      new JsonItemDoubleArrayValueControl(this);
-    
-    public override double[] Value {
-      get => Item.Value;
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
-  }
-
-  public class IntArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
-    public override Type TargetedJsonItemType => typeof(IntArrayJsonItem);
+  /*
+  public class StringArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
+    public override Type TargetedJsonItemType => typeof(StringArrayJsonItem);
 
     protected override int MinTypeValue => int.MinValue;
@@ -37,5 +23,5 @@
     public override UserControl Control =>
       new JsonItemBaseControl(this, new JsonItemIntArrayValueControl(this));
-    
+
     public override int[] Value {
       get => Item.Value;
@@ -46,4 +32,6 @@
     }
   }
+  */
+
 
   public abstract class ArrayValueVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>, IArrayJsonItemVM
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs	(revision 17519)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/DoubleVMs.cs	(revision 17519)
@@ -0,0 +1,62 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public class DoubleRangeVM : RangeVM<double, DoubleRangeJsonItem> {
+
+    protected override double MinTypeValue => double.MinValue;
+
+    protected override double MaxTypeValue => double.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemRangeControl(this);
+  }
+
+  public class DoubleArrayValueVM : ArrayValueVM<double, DoubleArrayJsonItem> {
+
+    protected override double MinTypeValue => double.MinValue;
+
+    protected override double MaxTypeValue => double.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemDoubleArrayValueControl(this);
+
+    public override double[] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+  }
+
+  public class DoubleMatrixValueVM : MatrixValueVM<double, DoubleMatrixJsonItem> {
+    public override UserControl Control =>
+      new JsonItemDoubleMatrixValueControl(this);
+
+    public override double[][] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+
+    protected override double MinTypeValue => double.MinValue;
+
+    protected override double MaxTypeValue => double.MaxValue;
+  }
+
+  public class DoubleValueVM : SingleValueVM<double, DoubleJsonItem> {
+
+    protected override double MinTypeValue => double.MinValue;
+    protected override double MaxTypeValue => double.MaxValue;
+
+    public override UserControl Control =>
+       new JsonItemDoubleValueControl(this);
+  }
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs	(revision 17519)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/IntVMs.cs	(revision 17519)
@@ -0,0 +1,46 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public class IntArrayValueVM : ArrayValueVM<int, IntArrayJsonItem> {
+
+    protected override int MinTypeValue => int.MinValue;
+
+    protected override int MaxTypeValue => int.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemBaseControl(this, new JsonItemIntArrayValueControl(this));
+
+    public override int[] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+  }
+
+  public class IntRangeVM : RangeVM<int, IntRangeJsonItem> {
+
+    protected override int MinTypeValue => int.MinValue;
+
+    protected override int MaxTypeValue => int.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemRangeControl(this);
+  }
+
+  public class IntValueVM : SingleValueVM<int, IntJsonItem> {
+
+    protected override int MinTypeValue => int.MinValue;
+    protected override int MaxTypeValue => int.MaxValue;
+
+    public override UserControl Control =>
+      new JsonItemIntValueControl(this);
+  }
+
+}
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/JsonItemVMBase.cs	(revision 17519)
@@ -9,5 +9,5 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public abstract class JsonItemVMBase<JsonItemType> : IJsonItemVM<JsonItemType>
+  public abstract class JsonItemVMBase<JsonItemType> : IJsonItemVM<JsonItemType> //TODO: RENAME, oder vlt JsonItems direkt als VM?
     where JsonItemType : class, IJsonItem 
   {
@@ -58,5 +58,5 @@
     }
 
-    public abstract Type TargetedJsonItemType { get; }
+    public virtual Type TargetedJsonItemType => typeof(JsonItemType);
     public abstract UserControl Control { get; }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/LookupJsonItemVM.cs	(revision 17519)
@@ -8,5 +8,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class LookupJsonItemVM : JsonItemVMBase<LookupJsonItem>, ILookupJsonItemVM {
-    public override Type TargetedJsonItemType => typeof(LookupJsonItem);
 
     public override UserControl Control => new LookupJsonItemControl(this);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/MatrixValueVM.cs	(revision 17519)
@@ -9,21 +9,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
 
-  public class DoubleMatrixValueVM : MatrixValueVM<double, DoubleMatrixJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleMatrixJsonItem);
-    public override UserControl Control =>
-      new JsonItemDoubleMatrixValueControl(this);
-
-    public override double[][] Value {
-      get => Item.Value;
-      set {
-        Item.Value = value;
-        OnPropertyChange(this, nameof(Value));
-      }
-    }
-
-    protected override double MinTypeValue => double.MinValue;
-
-    protected override double MaxTypeValue => double.MaxValue;
-  }
 
   public abstract class MatrixValueVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>, IMatrixJsonItemVM
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/RangeVM.cs	(revision 17519)
@@ -8,26 +8,4 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-
-  public class IntRangeVM : RangeVM<int, IntRangeJsonItem> {
-    public override Type TargetedJsonItemType => typeof(IntRangeJsonItem);
-
-    protected override int MinTypeValue => int.MinValue;
-
-    protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemRangeControl(this);
-  }
-
-  public class DoubleRangeVM : RangeVM<double, DoubleRangeJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleRangeJsonItem);
-
-    protected override double MinTypeValue => double.MinValue;
-
-    protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemRangeControl(this);
-  }
 
   public abstract class RangeVM<T, JsonItemType> : RangedValueBaseVM<T, JsonItemType>
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/SingleValueVM.cs	(revision 17519)
@@ -8,26 +8,6 @@
 
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
-  public class IntValueVM : SingleValueVM<int, IntJsonItem> {
-    public override Type TargetedJsonItemType => typeof(IntJsonItem);
-
-    protected override int MinTypeValue => int.MinValue;
-    protected override int MaxTypeValue => int.MaxValue;
-
-    public override UserControl Control =>
-      new JsonItemIntValueControl(this);
-  }
-
-  public class DoubleValueVM : SingleValueVM<double, DoubleJsonItem> {
-    public override Type TargetedJsonItemType => typeof(DoubleJsonItem);
-
-    protected override double MinTypeValue => double.MinValue;
-    protected override double MaxTypeValue => double.MaxValue;
-
-    public override UserControl Control =>
-       new JsonItemDoubleValueControl(this);
-  }
 
   public class BoolValueVM : JsonItemVMBase<BoolJsonItem> {
-    public override Type TargetedJsonItemType => typeof(BoolJsonItem);
 
     public bool Value { 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17518)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/ViewModels/StringValueVM.cs	(revision 17519)
@@ -9,5 +9,4 @@
 namespace HeuristicLab.JsonInterface.OptimizerIntegration {
   public class StringValueVM : JsonItemVMBase<StringJsonItem> {
-    public override Type TargetedJsonItemType => typeof(StringJsonItem);
     public override UserControl Control =>
        new JsonItemValidValuesControl(this);
@@ -37,5 +36,25 @@
       }
     }
+  }
 
+  public class StringArrayVM : JsonItemVMBase<StringArrayJsonItem> {
+    public override UserControl Control =>
+       new JsonItemConcreteItemArrayControl(this);
+
+    public string[] Value {
+      get => Item.Value;
+      set {
+        Item.Value = value;
+        OnPropertyChange(this, nameof(Value));
+      }
+    }
+
+    public IEnumerable<string> Range {
+      get => Item.ConcreteRestrictedItems;
+      set {
+        Item.ConcreteRestrictedItems = value;
+        OnPropertyChange(this, nameof(Range));
+      }
+    }
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.Designer.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.Designer.cs	(revision 17519)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/JsonItemConcreteItemArrayControl.Designer.cs	(revision 17519)
@@ -0,0 +1,122 @@
+﻿namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  partial class JsonItemConcreteItemArrayControl {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
+      this.groupBox1 = new System.Windows.Forms.GroupBox();
+      this.dataGridView = new System.Windows.Forms.DataGridView();
+      this.groupBox2 = new System.Windows.Forms.GroupBox();
+      this.concreteItemsRestrictor = new HeuristicLab.JsonInterface.OptimizerIntegration.ConcreteItemsRestrictor();
+      this.tableLayoutPanel1.SuspendLayout();
+      this.groupBox1.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).BeginInit();
+      this.groupBox2.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // tableLayoutPanel1
+      // 
+      this.tableLayoutPanel1.ColumnCount = 1;
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));
+      this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 20F));
+      this.tableLayoutPanel1.Controls.Add(this.groupBox1, 0, 0);
+      this.tableLayoutPanel1.Controls.Add(this.groupBox2, 0, 1);
+      this.tableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.tableLayoutPanel1.Location = new System.Drawing.Point(0, 0);
+      this.tableLayoutPanel1.Margin = new System.Windows.Forms.Padding(0);
+      this.tableLayoutPanel1.Name = "tableLayoutPanel1";
+      this.tableLayoutPanel1.RowCount = 2;
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50F));
+      this.tableLayoutPanel1.Size = new System.Drawing.Size(682, 350);
+      this.tableLayoutPanel1.TabIndex = 0;
+      // 
+      // groupBox1
+      // 
+      this.groupBox1.Controls.Add(this.dataGridView);
+      this.groupBox1.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox1.Location = new System.Drawing.Point(0, 0);
+      this.groupBox1.Margin = new System.Windows.Forms.Padding(0);
+      this.groupBox1.Name = "groupBox1";
+      this.groupBox1.Size = new System.Drawing.Size(682, 175);
+      this.groupBox1.TabIndex = 0;
+      this.groupBox1.TabStop = false;
+      this.groupBox1.Text = "Value";
+      // 
+      // dataGridView
+      // 
+      this.dataGridView.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      this.dataGridView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.dataGridView.Location = new System.Drawing.Point(3, 16);
+      this.dataGridView.Name = "dataGridView";
+      this.dataGridView.Size = new System.Drawing.Size(676, 156);
+      this.dataGridView.TabIndex = 0;
+      this.dataGridView.CellEndEdit += new System.Windows.Forms.DataGridViewCellEventHandler(this.dataGridView_CellEndEdit);
+      this.dataGridView.RowsRemoved += new System.Windows.Forms.DataGridViewRowsRemovedEventHandler(this.dataGridView_RowsRemoved);
+      // 
+      // groupBox2
+      // 
+      this.groupBox2.Controls.Add(this.concreteItemsRestrictor);
+      this.groupBox2.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.groupBox2.Location = new System.Drawing.Point(0, 175);
+      this.groupBox2.Margin = new System.Windows.Forms.Padding(0);
+      this.groupBox2.Name = "groupBox2";
+      this.groupBox2.Size = new System.Drawing.Size(682, 175);
+      this.groupBox2.TabIndex = 1;
+      this.groupBox2.TabStop = false;
+      this.groupBox2.Text = "Range";
+      // 
+      // concreteItemsRestrictor
+      // 
+      this.concreteItemsRestrictor.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.concreteItemsRestrictor.Location = new System.Drawing.Point(3, 16);
+      this.concreteItemsRestrictor.Margin = new System.Windows.Forms.Padding(0);
+      this.concreteItemsRestrictor.Name = "concreteItemsRestrictor";
+      this.concreteItemsRestrictor.Size = new System.Drawing.Size(676, 156);
+      this.concreteItemsRestrictor.TabIndex = 0;
+      // 
+      // JsonItemConcreteItemArrayControl
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.tableLayoutPanel1);
+      this.Margin = new System.Windows.Forms.Padding(0);
+      this.Name = "JsonItemConcreteItemArrayControl";
+      this.Size = new System.Drawing.Size(682, 350);
+      this.tableLayoutPanel1.ResumeLayout(false);
+      this.groupBox1.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).EndInit();
+      this.groupBox2.ResumeLayout(false);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel1;
+    private System.Windows.Forms.GroupBox groupBox1;
+    private System.Windows.Forms.DataGridView dataGridView;
+    private System.Windows.Forms.GroupBox groupBox2;
+    private ConcreteItemsRestrictor concreteItemsRestrictor;
+  }
+}
